import { declare } from '@babel/helper-plugin-utils';
import syntaxAsyncDoExpressions from '@babel/plugin-syntax-async-do-expressions';
import hoistVariables from '@babel/helper-hoist-variables';

var index = declare(({
  types: t,
  assertVersion
}) => {
  assertVersion("8.0.0-alpha.11");
  return {
    name: "proposal-async-do-expressions",
    inherits: syntaxAsyncDoExpressions,
    visitor: {
      DoExpression: {
        exit(path) {
          if (!path.is("async")) {
            return;
          }
          const {
            scope
          } = path;
          hoistVariables(path, id => {
            scope.push({
              id: t.cloneNode(id)
            });
          }, "var");
          const bodyPath = path.get("body");
          const completionRecords = bodyPath.getCompletionRecords();
          for (const p of completionRecords) {
            if (p.isExpressionStatement()) {
              p.replaceWith(t.returnStatement(p.node.expression));
            }
          }
          path.replaceWith(t.callExpression(t.arrowFunctionExpression([], bodyPath.node, true), []));
        }
      }
    }
  };
});

export { index as default };
//# sourceMappingURL=index.js.map
